#include "orb_device.h"
#include "orb_translator.h"
#include "hid_keys.h"
#include "chart_4.h"

Logical_orb orb_buffer( SpaceBall4000 );
Orb_translator translator;
byte b;
boolean has_initialized_orb=false;

PROGMEM Axis_mouse_binding axis_mouse_bindings[] =
  {
    { 5, MOUSE_AXIS_X, 4 },
    { 3, MOUSE_AXIS_Y, 4 }
  };

// PROGMEM Button_mouse_binding button_mouse_bindings[] =
//   {
//     { 0x01, 0x01 },
//     { 0x01 << 1, 0x01 << 1 },
//     { 0x01 << 2, 0x01 << 2 }
//   };

// PROGMEM Axis_key_binding axis_key_bindings[] =
//   {
//     { 0, 0, 450, 0, KEY_A },
//     { 0, 573, 1023, 0, KEY_D},
//     { 1, 0, 450, 0, KEY_W},
//     { 1, 573, 1023, 0, KEY_S},
//   };

PROGMEM Button_key_binding button_key_bindings[] = 
  {
    { 0x01 << 0, 0, KEY_1 },
    { 0x01 << 1, 0, KEY_2 },
    { 0x01 << 2, 0, KEY_3 },
    { 0x01 << 3, 0, KEY_4 },
    { 0x01 << 4, 0, KEY_5 },
    { 0x01 << 5, 0, KEY_6 },
    { 0x01 << 6, 0, KEY_R },
    { 0x01 << 7, 0, KEY_SPACE },
    { 0x01 << 8, 0, KEY_C },
    { 0x01 << 10, 0, KEY_F }
  };


const PROGMEM short Polarity[] = { 1,-1,-1,-1,-1,-1};

void setup()
{
  Serial.begin( 9600 );

  translator.set_axis_map( Axis_map_spaceball_4k );
  translator.set_polarity( Polarity );
  translator.set_fourway_bindings( &WASD_fourway_binding, 1 );
  translator.send_joystick_reports = false;
  translator.set_axis_mouse_bindings( axis_mouse_bindings, 2 );
  translator.set_button_key_bindings( button_key_bindings, 10 );
//   translator.set_axis_key_bindings( axis_key_bindings, 10 );
}


void loop()
{
  if ( (!has_initialized_orb) && (orb_buffer.physical_buttons & 1) )
    {
      orb_device.safe_send_serial_P(spaceball_setup_string);
      has_initialized_orb = true;
    }
  orbduino_loopfunc( orb_buffer, translator, orb_device );
}
